 '----------------------------------------------------------
'  PROGRAM: SNOW.BAS            PROGRAMMER: A. KELLETT
'  DATE-WRITTEN: 02/28/91
'  USING POWER BASIC V2.00
'       THIS PROGRAM PRODUCES FALLING SNOWFLAKES ON
'       THE SCREEN TO HELP PREVENT "BURN-IN" OF
'       THE MONITOR.
'  VERSION: 0.9    LAST UPDATED: 00/00/00
'----------------------------------------------------------
VERSION$ = "0.90"
NEWCOMMAND$ = UCASE$(COMMAND$)
IF NEWCOMMAND$ <> "H" AND NEWCOMMAND$ <> "M" AND NEWCOMMAND$ <> "L" THEN
   SCROLLSPEED = .35
ELSE
   IF NEWCOMMAND$ = "H" THEN      '*** HIGH SPEED, SMALL DELAY ***
      SCROLLSPEED = .07
   ELSE
      IF NEWCOMMAND$ = "M" THEN   '*** MED SPEED, MEDIUM DELAY ***
         SCROLLSPEED = .28
      ELSE
         IF NEWCOMMAND$ = "L" THEN  '*** SNOW SPEED, LARGE DELAY ***
            SCROLLSPEED = .55
         END IF
      END IF
   END IF
END IF
CLS
LOCATE 16,20:PRINT "SYNTAX IS:   SNOW L      LOW SPEED SNOW "
LOCATE 17,20:PRINT "             SNOW M      MEDIUM SPEED SNOW"
LOCATE 18,20:PRINT "             SNOW H      HIGH SPEED SNOW"
LOCATE 20,15:PRINT "SNOW V";VERSION$;" - ANDY K.   PRESS ANY KEY TO QUIT."
GOSUB INITIALIZE
DELAY 2.5
GOSUB SNOWING
CLS
LOCATE 20,10:PRINT "SNOW V";VERSION$;" - ANDY K."
END

'  INITIALIZE SNOW PATTERNS AND SET UP THE TABLE
'----------------------------------------------------------
INITIALIZE:
   DIM SNOW$(24)
   LINE1$ =_
"*      *     *      *      *      *      *      *      *      *      *      *"
   LINE2$ =_
"  *      *     *      *      *      *      *      *      *      *      *     "
   LINE3$ =_
"       *   *     *       *     *    *    *         *         *      *     *  "
   LINE4$ =_
"           *          *        *             *           *            *      "
   LINE5$ =_
" *  *    *     *  *    *     *    *  *     *     *   *    *    *   *       * "
   LINE6$ =_
"*          *        *           *      *       *      *       *        *     "
   LINE7$ =_
"             *          *               *         * *       *    *           "
   LINE8$ =_
"*     *         *          *         *      *          *                  *  "

   SNOW$(1) = LINE1$:SNOW$(2) = LINE2$:SNOW$(3) = LINE3$:SNOW$(4) = LINE4$
   SNOW$(5) = LINE5$:SNOW$(6) = LINE6$:SNOW$(7) = LINE7$:SNOW$(8) = LINE4$
   SNOW$(9) = LINE8$:SNOW$(10) = LINE1$:SNOW$(11) = LINE2$:SNOW$(12) = LINE4$
   SNOW$(13) = LINE3$:SNOW$(14) = LINE4$:SNOW$(15) = LINE5$:SNOW$(16) = LINE4$
   SNOW$(17) = LINE6$:SNOW$(18) = LINE7$:SNOW$(19) = LINE8$:SNOW$(20) = LINE4$
   SNOW$(21) = LINE1$:SNOW$(22) = LINE2$:SNOW$(23) = LINE3$:SNOW$(24) = LINE4$

RETURN

'  DISPLAY THE SNOW, MOVE THE PATTERNS UPWARD, QUIT AT KEYPRESS
'----------------------------------------------------------
SNOWING:
   KY$ = ""
   WHILE KY$ = ""
      FOR I% = 1 TO 24
	 LOCATE I%,1:PRINT SNOW$(I%);
      NEXT I%
      TEMP$ = SNOW$(24)
      FOR I% = 24 TO 2 STEP -1
         SNOW$(I%) = SNOW$(I% - 1)
      NEXT I%
      SNOW$(1) = TEMP$
      DELAY SCROLLSPEED
      KY$ = INKEY$
   WEND
RETURN

